Attribute VB_Name = "MP3_ID3v1"
' ************************************************************************
' * Infos:                                                               *
' * ======                                                               *
' *  To your the GenreList you have to call the InitGenreList sub    *
' *                                                                      *
' ************************************************************************

Option Explicit



Public Type ID1Info
   Artist As String
   Title As String
   Album As String
   Track As String
   genre As String
   Comment As String
   Year As String
End Type


Public genreList(126) As String
   
   

Public Const FILE_NOT_EXISTS = -3
Public Const NOT_A_SUPPORTED_FILE = -2
Public Const NO_ID_TAG = -1
Public Const NO_ERROR = 0


Function CHK_Invalid_Chars(TextSTR As String) As String
Dim s As String
Dim i As Integer

  For i = 1 To Len(TextSTR)
    
    s = Mid$(TextSTR, i, 1)
    
    If (s = "\") Or (s = "/") Or (s = ":") Or _
       (s = "*") Or (s = Chr(34)) Or (s = "?") Or _
       (s = "<") Or (s = ">") Or (s = ">") Then
       TextSTR = Left(TextSTR, i - 1) & Mid$(TextSTR, i + 1)
    End If
  
  Next i
    
  CHK_Invalid_Chars = TextSTR
End Function

Function DEL_CHR0_STR(TextSTR As String) As String
Dim i As Integer

  If Len(TextSTR) > 0 Then
    i = 1
    
    Do Until InStr(i, TextSTR, Chr(0)) = 0
      i = InStr(i, TextSTR, Chr(0))
      TextSTR = Left(TextSTR, i - 1) & Mid$(TextSTR, i + 1)
    Loop
  
  End If
  
  
  DEL_CHR0_STR = Trim(TextSTR)
End Function

Function ADD_CHR0_STR(TextSTR As String, TextLength As Integer, Filler As Integer) As String
Dim i As Integer
Dim m As Integer

  TextSTR = Trim(TextSTR)
  
  
  If Len(TextSTR) > TextLength Then
    TextSTR = Mid$(TextSTR, 1, TextLength)
  ElseIf Len(TextSTR) < TextLength Then
    For i = 1 To (TextLength - Len(TextSTR))
      TextSTR = TextSTR & Chr(Filler)
    Next i
  End If
  
  ADD_CHR0_STR = TextSTR
End Function


Function PutIDTAG(FileName As String, IDTAG As ID1Info) As Integer
Dim Strg As String
Dim outSTR As String
Dim PUTstart As Long
 
    
  If CHK_File(FileName) = False Then
    PutIDTAG = FILE_NOT_EXISTS
    Exit Function
  End If
  
  If FileLen(FileName) < 127 Then
    PutIDTAG = NOT_A_SUPPORTED_FILE
    Exit Function
  End If
  
  
  If CHK_Writeprotected(FileName) Then
    PutIDTAG = -9
    Exit Function
  End If
  
  
  Open FileName For Binary Access Read As #1
    
    Strg = String(3, "!")
    Get #1, FileLen(FileName) - 127, Strg
  Close #1
  
  If UCase(Strg) <> "TAG" Then
    PUTstart = FileLen(FileName)
  Else
    PUTstart = FileLen(FileName) - 127
  End If
    
  outSTR = "TAG" & _
           ADD_CHR0_STR(IDTAG.Title, 30, 0) & _
           ADD_CHR0_STR(IDTAG.Artist, 30, 0) & _
           ADD_CHR0_STR(IDTAG.Album, 30, 0) & _
           ADD_CHR0_STR(IDTAG.Year, 4, 0) & _
           ADD_CHR0_STR(IDTAG.Comment, 29, 0) & _
           IDTAG.Track & _
           IDTAG.genre
  
  Open FileName For Binary Access Write As #1
    Put #1, PUTstart, outSTR
  Close #1
  
  
  PutIDTAG = NO_ERROR
End Function

Function GetIDTAG(FileName As String, IDTAG As ID1Info) As Integer
Dim Strg As String
  
  If CHK_File(FileName) = False Then
    GetIDTAG = FILE_NOT_EXISTS
    Exit Function
  End If
  
  If FileLen(FileName) < 127 Then
    GetIDTAG = NOT_A_SUPPORTED_FILE
    Exit Function
  End If
  
  Open FileName For Binary Access Read As #1
  
    Strg = String(3, "!"): Get #1, FileLen(FileName) - 127, Strg
    
    
    If UCase(Strg) <> "TAG" Then
      
      GetIDTAG = NO_ID_TAG
      Close #1
      Exit Function
    Else

      Strg = String(30, "!"): Get #1, , Strg: IDTAG.Title = DEL_CHR0_STR(Strg)
      Strg = String(30, "!"): Get #1, , Strg: IDTAG.Artist = DEL_CHR0_STR(Strg)
      Strg = String(30, "!"): Get #1, , Strg: IDTAG.Album = DEL_CHR0_STR(Strg)
      Strg = String(4, "!"):  Get #1, , Strg: IDTAG.Year = DEL_CHR0_STR(Strg)
      Strg = String(29, "!"): Get #1, , Strg: IDTAG.Comment = DEL_CHR0_STR(Strg)
      Strg = String(1, "!"):  Get #1, , Strg: IDTAG.Track = Strg
      Strg = String(1, "!"):  Get #1, , Strg: IDTAG.genre = Strg
    End If
  
  Close #1
  
  GetIDTAG = NO_ERROR
End Function

Function ChangeTAG(FileName As String, NewTAG As ID1Info) As Integer
Dim ErrResult As Integer
Dim IDTAG As ID1Info
  
  ErrResult = GetIDTAG(FileName, IDTAG)
      
  If ErrResult = NO_ID_TAG Then
    IDTAG.Title = ""
    IDTAG.Artist = ""
    IDTAG.Album = ""
    IDTAG.Comment = ""
    IDTAG.Year = ""
    IDTAG.genre = Chr(0)
    ErrResult = 0
  End If
  
  If ErrResult <> 0 Then
    ChangeTAG = ErrResult
  Else
    If NewTAG.Title <> "" Then IDTAG.Title = NewTAG.Title
    If NewTAG.Artist <> "" Then IDTAG.Artist = NewTAG.Artist
    If NewTAG.Album <> "" Then IDTAG.Album = NewTAG.Album
    If NewTAG.Comment <> "" Then IDTAG.Comment = NewTAG.Comment
    If NewTAG.Year <> "" Then IDTAG.Year = NewTAG.Year
    If NewTAG.genre <> "" Then IDTAG.genre = NewTAG.genre
  
    ErrResult = PutIDTAG(FileName, IDTAG)
        
    ChangeTAG = ErrResult
  End If
        
End Function

Function CHK_Writeprotected(FileName As String) As Boolean
  
  On Error GoTo ERRlog
    Open FileName For Binary Access Write As #111
    Close #111
  On Error GoTo 0
  
  CHK_Writeprotected = False
  Exit Function
  
ERRlog:
  CHK_Writeprotected = True
End Function


Function CHK_File(FileName As String) As Boolean
Dim fn As Object

  Set fn = CreateObject("Scripting.FileSystemObject")
  CHK_File = fn.FileExists(FileName)
  
End Function

Function CHK_Folder(Foldername As String) As Boolean
Dim fn As Object

  Set fn = CreateObject("Scripting.FileSystemObject")
  
  CHK_Folder = fn.FolderExists(Foldername)
End Function

Function TrimPATH(PathANDFile As String) As String
Dim i As Long

  For i = Len(PathANDFile) To 1 Step -1
    If Mid$(PathANDFile, i, 1) = "\" Then
       TrimPATH = Mid$(PathANDFile, i + 1)
       Exit Function
    End If
  Next i
  
  TrimPATH = ""
End Function

Function TrimFileName(PathANDFile As String) As String
Dim i As Long

  For i = Len(PathANDFile) To 1 Step -1
    If Mid$(PathANDFile, i, 1) = "\" Then
       TrimFileName = Mid$(PathANDFile, 1, i - 1)
       Exit Function
    End If
  Next i
  
  TrimFileName = ""
End Function




Sub InitGenreList()
    genreList(0) = "Blues"
    genreList(1) = "Classic Rock"
    genreList(10) = "New Age"
    genreList(100) = "Humour"
    genreList(101) = "Speech"
    genreList(102) = "Chanson"
    genreList(103) = "Opera"
    genreList(104) = "Chamber Music"
    genreList(105) = "Sonata"
    genreList(106) = "Symphony"
    genreList(107) = "Booty Brass"
    genreList(108) = "Primus"
    genreList(109) = "Porn Groove"
    genreList(11) = "Oldies"
    genreList(110) = "Satire"
    genreList(111) = "Slow Jam"
    genreList(112) = "Club"
    genreList(113) = "Tango"
    genreList(114) = "Samba"
    genreList(115) = "Folklore"
    genreList(116) = "Ballad"
    genreList(117) = "Poweer Ballad"
    genreList(118) = "Rhytmic Soul"
    genreList(119) = "Freestyle"
    genreList(12) = "Other"
    genreList(120) = "Duet"
    genreList(121) = "Punk Rock"
    genreList(122) = "Drum Solo"
    genreList(123) = "A Capela"
    genreList(124) = "Euro-House"
    genreList(125) = "Dance Hall"
    genreList(13) = "Pop"
    genreList(14) = "R&B"
    genreList(15) = "Rap"
    genreList(16) = "Reggae"
    genreList(17) = "Rock"
    genreList(18) = "Techno"
    genreList(19) = "Industrial"
    genreList(2) = "Country"
    genreList(20) = "Alternative"
    genreList(21) = "Ska"
    genreList(22) = "Death Metal"
    genreList(23) = "Pranks"
    genreList(24) = "Soundtrack"
    genreList(25) = "Euro-Techno"
    genreList(26) = "Ambient"
    genreList(27) = "Trip-Hop"
    genreList(28) = "Vocal"
    genreList(29) = "Jazz+Funk"
    genreList(3) = "Dance"
    genreList(30) = "Fusion"
    genreList(31) = "Trance"
    genreList(32) = "Classical"
    genreList(33) = "Instrumental"
    genreList(34) = "Acid"
    genreList(35) = "House"
    genreList(36) = "Game"
    genreList(37) = "Sound Clip"
    genreList(38) = "Gospel"
    genreList(39) = "Noise"
    genreList(4) = "Disco"
    genreList(40) = "AlternRock"
    genreList(41) = "Bass"
    genreList(42) = "Soul"
    genreList(43) = "Punk"
    genreList(44) = "Space"
    genreList(45) = "Meditative"
    genreList(46) = "Instrumental Pop"
    genreList(47) = "InstrumentalRock"
    genreList(48) = "Ethnic"
    genreList(49) = "Gothic"
    genreList(5) = "Funk"
    genreList(50) = "Darkwave"
    genreList(51) = "Techno-Industrial"
    genreList(52) = "Electronic"
    genreList(53) = "Pop-Folk"
    genreList(54) = "Eurodance"
    genreList(55) = "Dream"
    genreList(56) = "Southern Rock"
    genreList(57) = "Comedy"
    genreList(58) = "Cult"
    genreList(59) = "Gangsta"
    genreList(6) = "Grunge"
    genreList(60) = "Top 40"
    genreList(61) = "Christian Rap"
    genreList(62) = "Pop/Funk"
    genreList(63) = "Jungle"
    genreList(64) = "Native American"
    genreList(65) = "Cabaret"
    genreList(66) = "New Wave"
    genreList(67) = "Psychadelic"
    genreList(68) = "Rave"
    genreList(69) = "Showtunes"
    genreList(7) = "Hip-Hop"
    genreList(70) = "Trailer"
    genreList(71) = "Lo-Fi"
    genreList(72) = "Tribal"
    genreList(73) = "Acid Punk"
    genreList(74) = "Acid Jazz"
    genreList(75) = "Polka"
    genreList(76) = "Retro"
    genreList(77) = "Musical"
    genreList(78) = "Rock&Roll"
    genreList(79) = "Hard Rock"
    genreList(8) = "Jazz"
    genreList(80) = "Folk"
    genreList(81) = "Folk-Rock"
    genreList(82) = "National Folk"
    genreList(83) = "Swing"
    genreList(84) = "Fast Fusion"
    genreList(85) = "Bebob"
    genreList(86) = "Latin"
    genreList(87) = "Revival"
    genreList(88) = "Celtic"
    genreList(89) = "Bluegrass"
    genreList(9) = "Metal"
    genreList(90) = "Avantgarde"
    genreList(91) = "Gothic Rock"
    genreList(92) = "Progressive Rock"
    genreList(93) = "Psychedelic Rock"
    genreList(94) = "Symphonic Rock"
    genreList(95) = "Slow Rock"
    genreList(96) = "Big Band"
    genreList(97) = "Chorus"
    genreList(98) = "Easy Listening"
    genreList(99) = "Acoustic"
End Sub

